<?php
// определяем кодировку
header('Content-type: text/html; charset=utf-8');
// Создаем объект бота
$bot = new Bot();
// Обрабатываем пришедшие данные
$bot->init('php://input');

/**
 * Class Bot
 */
class Bot
{
    // <bot_token> - созданный токен для нашего бота от @BotFather
    private $botToken = "ВАШ_ТОКЕН";

    // адрес для запросов к API Telegram
    private $apiUrl = "https://api.telegram.org/bot";

    // Приветствие для админа при старте

    public function init($data_php)
    {
        // создаем массив из пришедших данных от API Telegram
        $data = $this->getData($data_php);

//        // пишем лог
//        $this->setFileLog($data, "log.txt");

        // получаем id чата если просто сообщение
        $chat_id = $data['message']['chat']['id'];
        // получаем id чата если событие по кнопке callback_query
        $callback_chat_id = $data['callback_query']['message']['chat']['id'];

        // готовим кнопки
        $inlineBtn = [
            ['text' => 'Редактировать', 'callback_data' => 'edit_msg'],
            ['text' => 'Удалить', 'callback_data' => 'del_msg'],
        ];
        $btns = $this->setInlineButton($inlineBtn);

        // проверяем что пришло - производим действие
        // если пришло просто сообщение
        if (array_key_exists('message', $data)) {
            // если это старт диалога
            if ($data['message']['text'] == "/start") {
                // готовим данные для отправки
                $content = [
                    'chat_id' => $chat_id,
                    'text' => 'Сообщение для редактирования',
                    'reply_markup' => $btns,
                ];
                // отправляем сообщение
                $this->sendMessage($content);
            } elseif (array_key_exists('reply_to_message', $data['message'])) {
                // если это ответ на сообщение

                // берм id сообщения которое надо отредактировать
                // зашито в тексте для примера
                preg_match("~([0-9])+$~", $data['message']['reply_to_message']['text'], $matches);

                // готовим данные
                $content = [
                    'chat_id' => $chat_id,
                    'message_id' => $matches[0],
                    'reply_markup' => $btns,
                    'text' => $data['message']['text'], // текст который отправили
                ];
                // редактируем сообщение
                $this->requestToTelegram($content, "editMessageText");
            } else {
                // если другое не запланированное текстовое сообщение
                $this->sendMessage(['chat_id' => $chat_id, 'text' => "Не понимаю команду. 1"]);
            }
        } elseif(array_key_exists('callback_query', $data)) {
            // если пришел запрос от кнопок
            if (preg_match("~^edit_msg~", $data['callback_query']['data'])) {
                // если это запрос на редактирование

                //готовим данные
                $content = [
                    'chat_id' => $callback_chat_id,
                    // зашиваем id сообщения которое надо отредактировать
                    'text' => "Ваш новый текст для сообщения - " . $data['callback_query']['message']['message_id'],
                    // автоматически подставляем для ответа
                    'reply_markup' => json_encode(['force_reply' => true], true),
                ];
                // отправляем сообщение
                $this->sendMessage($content);
            } elseif (preg_match("~^del_msg~", $data['callback_query']['data'])) {
                //  если пришел запрос на удаление

                // готовим данные
                $content = [
                    'chat_id' => $callback_chat_id,
                    'message_id' => $data['callback_query']['message']['message_id'],
                ];
                // отправляем запрос на удаление
                $this->requestToTelegram($content, "deleteMessage");
            }
        }
    }

    /** генерируем кнопку
     * @param $auth_key
     * @return string
     */
    private function setInlineButton($data)
    {
        $keyboard = [
            'inline_keyboard' => [$data],
        ];
        return json_encode($keyboard);
    }

    // отправка текстового сообщения
    private function sendMessage($data)
    {
        $this->requestToTelegram($data, "sendMessage");
    }

    // логирование
    private function setFileLog($data, $file)
    {
        $fh = fopen($file, 'a') or die('can\'t open file');
        ((is_array($data)) || (is_object($data))) ? fwrite($fh, print_r($data, TRUE) . "\n") : fwrite($fh, $data . "\n");
        fclose($fh);
    }

    /**
     * Парсим что приходит преобразуем в массив
     * @param $data
     * @return mixed
     */
    private function getData($data)
    {
        return json_decode(file_get_contents($data), TRUE);
    }

    /** Отправляем запрос в Телеграмм
     * @param $data
     * @param string $type
     * @return mixed
     */
    private function requestToTelegram($data, $type)
    {
        $result = null;

        if (is_array($data)) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $this->apiUrl . $this->botToken . '/' . $type);
            curl_setopt($ch, CURLOPT_POST, count($data));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
            $result = curl_exec($ch);
            curl_close($ch);
        }
        return $result;
    }
}